# btsgtk/application.py
#  Copyright (C) 2008 Luca Bruno <lethalman88@gmail.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; see the file COPYING.  If not, write to
#  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.

from main_window import MainWindow
from status_icon import StatusIcon
import gtk
import os

class BtsGtkApplication (object):
    bts_command = "/usr/bin/bts"
    logo = "/usr/share/pixmaps/debian-logo.png"

    def __init__ (self):
        self.main_window = None
        self.status_icon = None

    def get_main_window (self):
        return self.main_window

    def get_manager (self):
        return self.main_window.manager

    def open_bug (self, number):
        self.get_manager().open (number)

    def run (self):
        gtk.window_set_default_icon_from_file (self.logo)
        self.main_window = MainWindow (self)
        self.main_window.show_all ()
        self.status_icon = StatusIcon (self)
        gtk.main ()

    def run_bts (self, args):        
        #os.spawnl (os.P_NOWAIT, self.bts_command, self.bts_command, *args)
        print self.bts_command, self.bts_command, args

    def quit (self, *args):
        gtk.main_quit ()
