# btsgtk/btsop.py
#  Copyright (C) 2008 Luca Bruno <lethalman88@gmail.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; see the file COPYING.  If not, write to
#  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.

import gtk

class BTSOp (gtk.VBox):
    name = ""
    description = ""

    def __init__ (self, application):
        gtk.VBox.__init__ (self, spacing=6)
        self.application = application
        self.bug = None

    def setup (self, bug):
        self.bug = bug
        self.setup_ui ()
        self.show ()

    def setup_ui (self):
        pass

    def execute (self):
        if not self.bug:
            raise RuntimeError ("BTS operation hasn't been setup correctly")
        commandline = self.commandline ()
        if not commandline:
            commandline = []
        args = [self.name, str (self.bug.get_number ())] + commandline
        self.application.run_bts (args)

    def commandline (self):
        pass

class BTSClone (BTSOp):
    name = "clone"
    description = "Duplicate a bug report"

    def setup_ui (self):
        label = gtk.Label ("The bug will be cloned.")
        label.show ()
        self.pack_start (label, expand=False)

class BTSOpOptionalEntry (BTSOp):
    label = ""
    entry_label = ""

    def setup_ui (self):
        label = gtk.Label (self.label)
        label.show ()
        self.pack_start (label, expand=False)

        hbox = gtk.HBox (spacing=6)
        hbox.show ()
        label = gtk.Label ("%s <i>(optional)</i>:" % self.entry_label)
        label.set_use_markup (True)
        label.show ()
        hbox.pack_start (label, expand=False)
        self.entry = gtk.Entry ()
        self.entry.show ()
        hbox.pack_start (self.entry)
        self.pack_start (hbox, expand=False)

    def commandline (self):
        optional = self.entry.get_text ()
        if optional:
            return [optional]

class BTSReopen (BTSOpOptionalEntry):
    name = "reopen"
    description = "Reopen a bug"
    label = "The bug will be reopened."
    entry_label = "Submitter"

operations = [
    BTSClone,
    BTSReopen
]


