# btsgtk/dialogs.py
#  Copyright (C) 2008 Luca Bruno <lethalman88@gmail.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; see the file COPYING.  If not, write to
#  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.

import gtk

def error_dialog (parent, message):
    dialog = gtk.MessageDialog (parent, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                                gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, message)
    dialog.connect ('response', lambda *args: dialog.destroy ())
    dialog.set_title ('Reportbug')
    dialog.show_all ()

class CustomDialog (gtk.Dialog):
    def __init__ (self, parent, stock_image, message, buttons, *args, **kwargs):
        gtk.Dialog.__init__ (self, "BtsGTK", parent,
                             gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                             buttons)
        # Try following the HIG
        self.set_default_response (buttons[-1]) # this is the response of the last button
        self.set_border_width (5)

        vbox = gtk.VBox (spacing=10)
        vbox.set_border_width (6)
        self.vbox.pack_start (vbox)
        
        # The header image + label
        hbox = gtk.HBox (spacing=10)
        vbox.pack_start (hbox, expand=False)

        align = gtk.Alignment (0.5, 0.5, 1.0, 1.0)
        hbox.pack_start (align, expand=False)

        image = gtk.image_new_from_stock (stock_image, gtk.ICON_SIZE_DIALOG)
        hbox.pack_start (image)
        
        label = gtk.Label (message)
        label.set_line_wrap (True)
        label.set_justify (gtk.JUSTIFY_FILL)
        hbox.pack_start (label, expand=False)

        self.setup_dialog (vbox, *args, **kwargs)

class InputStringDialog (CustomDialog):
    def __init__ (self, parent, message):
        CustomDialog.__init__ (self, parent, gtk.STOCK_DIALOG_INFO, message,
                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))

    def setup_dialog (self, vbox):
        self.entry = gtk.Entry ()
        vbox.pack_start (self.entry, expand=False)

    def get_value (self):
        return self.entry.get_text ()
