# btsgtk/manager.py
#  Copyright (C) 2008 Luca Bruno <lethalman88@gmail.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; see the file COPYING.  If not, write to
#  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.

import gtk

from batch import Batch

class Manager (gtk.Notebook):
    def __init__ (self, application):
        gtk.Notebook.__init__ (self)
        self.application = application
        self.batches = {}

    def open (self, number):
        if self.batches.has_key (number):
            batch = self.batches[number]
            page_num = self.page_num (batch)
            self.set_current_page (page_num)
        else:
            batch = Batch (self.application, number)
            self.append_page (batch, gtk.Label (str (number)))
            # Highlight the newly created bug
            page_num = self.page_num (batch)
            self.set_current_page (page_num)
            self.batches[number] = batch
        return batch

    def close_current (self):
        page_num = self.get_current_page ()
        batch = self.get_nth_page (page_num)
        del self.batches[batch.get_bug_number ()]
        self.remove_page (page_num)

    def execute (self):
        for batch in self.batches.itervalues ():
            batch.execute ()
            page_num = self.page_num (batch)
            self.remove_page (page_num)
